clc; clear all; close all;
x = imread('cameraman.tif');
figure; imshow(x); title('Original Image');
x = double(x);
%Simulation of motion blur
LEN = 12;
THETA =2;
h = fspecial('motion', LEN, THETA);
% input image 
y =  conv2(x,h,'same');
figure; imshow(uint8(y)); title('Input');
iterN = 2;
%x_hat = MAP(y,h,iterN);
p = [1 -2 1]; % filter
%ptp = imfilter(p',p); % P transpoze convolve with P
%hth = imfilter(h',h); % h transpoze convolve with h
x_hat = y;
gamma = 0.5;
%alpha = 1;
for i = 1:iterN,
    res = y - imfilter(x_hat,h);
    ptpf = imfilter(imfilter(x_hat,p),p'); %P transpoze P concolve with f
    hthf = imfilter(imfilter(x_hat,h),h'); %h transpoze h concolve with f
    grad = -2*imfilter(y,h) + 2*hthf + 2*gamma*ptpf;
    hthg = imfilter(imfilter(grad,h),h'); %h transpoze h concolve with g
    ptpg = imfilter(imfilter(grad,p),p'); %P transpoze P concolve with g
    d1 = 2*gamma*(imfilter(ptpf,grad)) - 2*(imfilter((imfilter(res,h)),grad));
    d2 = 2* (imfilter(hthg,grad) + gamma * (imfilter(ptpg,grad)));
    alpha = d1/d2;
    x_hat = x_hat - alpha*grad;
end
figure; imshow(uint8(x_hat)); title('Restored');